import React from 'react';
import PropTypes from 'prop-types';

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};

var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};

var ReactCallbagProps = function (_React$Component) {
  inherits(ReactCallbagProps, _React$Component);

  function ReactCallbagProps() {
    var _temp, _this, _ret;

    classCallCheck(this, ReactCallbagProps);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.talkbacks = {}, _this.state = {}, _this.subscribe = function (key, callbag) {
      callbag(0, function (type, data) {
        var _this$setState;

        if (type === 0) _this.talkbacks[key] = data;else if (type === 1) _this.setState((_this$setState = {}, _this$setState[key] = data, _this$setState));else if (type === 2) _this.unsubscribe(key, callbag);

        if (type === 0 || type === 1) _this.talkbacks[key](1);
      });
    }, _this.unsubscribe = function (key, callbag) {
      var _this$setState2;

      _this.setState((_this$setState2 = {}, _this$setState2[key] = undefined, _this$setState2));
      delete _this.talkbacks[key];
    }, _temp), possibleConstructorReturn(_this, _ret);
  }

  ReactCallbagProps.prototype.componentDidMount = function componentDidMount() {
    var _this2 = this;

    Object.keys(this.props).filter(function (key) {
      return key !== 'children';
    }).forEach(function (key) {
      var callbag = _this2.props[key];
      if (callbag) {
        _this2.subscribe(key, callbag);
      }
    });
  };

  ReactCallbagProps.prototype.componentDidUpdate = function componentDidUpdate(prevProps) {
    var _this3 = this;

    // look for new props
    Object.keys(this.props).forEach(function (key) {
      var newCallbag = _this3.props[key];
      var oldCallbag = prevProps[key];
      if (newCallbag !== oldCallbag) {
        if (oldCallbag === undefined) {
          // got a new one!
          _this3.subscribe(key, newCallbag);
        } else {
          // callbag changed, unsubscribe and resubscribe to new one
          var talkback = _this3.talkbacks[key];
          if (talkback) {
            talkback(2);
          }
          _this3.unsubscribe(key, oldCallbag);
          _this3.subscribe(key, newCallbag);
        }
      }
    });
    Object.keys(prevProps).forEach(function (key) {
      var newCallbag = _this3.props[key];
      var oldCallbag = prevProps[key];
      if (oldCallbag && !newCallbag) {
        _this3.talkbacks[key](2);
        _this3.unsubscribe(key, oldCallbag);
      }
    });
  };

  ReactCallbagProps.prototype.componentWillUnmount = function componentWillUnmount() {
    var _this4 = this;

    Object.keys(this.talkbacks).forEach(function (key) {
      return _this4.talkbacks[key](2);
    });
  };

  ReactCallbagProps.prototype.render = function render() {
    return this.props.children(this.state);
  };

  return ReactCallbagProps;
}(React.Component);
process.env.NODE_ENV !== "production" ? ReactCallbagProps.propTypes = {
  children: PropTypes.func
} : void 0;

export default ReactCallbagProps;
